'use strict';

exports.__esModule = true;

var _create = require('../utils/create');

var _create2 = _interopRequireDefault(_create);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _create2.default)({
  render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: _vm.b({
        on: _vm.open,
        disabled: _vm.disabled
      }), style: _vm.style, on: { "click": _vm.onClick } }, [_c('div', { class: _vm.b('node') }, [_vm.loading ? _c('loading', { class: _vm.b('loading') }) : _vm._e()], 1)]);
  },

  name: 'switch',

  props: {
    value: [Boolean, String],
    loading: Boolean,
    disabled: Boolean,
    size: {
      type: String,
      default: '30px'
    },
    activeValue: {
      type: String
    },
    inactiveValue: {
      type: String
    }
  },

  computed: {
    style: function style() {
      return {
        fontSize: this.size
      };
    },

    open: {
      get: function get() {
        if (this.activeValue && this.inactiveValue) {
          if (this.value === this.activeValue) {
            return true;
          }
          if (this.value === this.inactiveValue) {
            return false;
          }
        }
        return this.value;
      },
      set: function set(value) {
        var open = void 0;
        if (value) {
          open = this.activeValue ? this.activeValue : value;
        } else {
          open = this.inactiveValue ? this.inactiveValue : value;
        }
        this.$emit('input', open);
        this.$emit('change', open);
      }
    }
  },

  methods: {
    onClick: function onClick() {
      if (!this.disabled && !this.loading) {
        this.open = !this.open;
      }
    }
  }
});